import { Observable } from "rxjs";

export interface ITransport {
    send(message: string): void
    emit(event: string, data: any): void;
    getResponse(): Observable<any>
    getEventNotification(): Observable<any>
}

export interface ITransportTransmission extends ITransport{
    // send(message: string): void
    // emit(event: string, data: any): void;
}

export interface ITransportReceiving extends ITransport{
    // returnResponse(): Observable<any>
    // returnEventNotification(): Observable<any>
}

export interface TransportSettings {
    role: 'Server' | 'Client',
    profileInfo: ProfileInfo,
}

export interface ProfileInfo {
    id: string,
    name: string,
    url?: string | null,
    port?: number | null
}

export interface TransmitterProfile {
    uuid: string,
    name: string,
    dateCreated: Date,
    data?: any
}

export interface ReceiverProfile {
    uuid: string,
    name: string,
    dateCreated: Date,
    data?: any
}

export interface TransportEventNotification {
    event: string,
    description: string,
    data?: any
} 