import { interval, Subject } from "rxjs"
import { v4 as uuidv4 } from 'uuid'
import { TransportService } from "../transport/transport.service"

const transmitterService = new TransportService()

// this one to emulate broadcasting notification. Assuming the receiver has subscribed for this
let count = 0
let response = interval(1000)
response.subscribe(eachInterval => {
    transmitterService.emit({
        header: {
            messageID: uuidv4(),
            messageName: `NotificationMessage`
        },
        data: 'just a test Notification'
    })
})

// For incoming requests and return data just for testing
let incomingRequest = new Subject<any>()
incomingRequest.subscribe(request => {
    // return 10 messages
    let count = 0
    let response = interval(1000)
    response.subscribe(eachInterval => {
        count++
        if (count < 10) {
            transmitterService.emit({
                header: {
                    messageID: request.header.messageID,
                    messageName: `ResponseMessage`
                },
                data: 'just a test Response'
            })
        } else {
            transmitterService.emit({
                header: {
                    messageID: request.header.messageID,
                    messageName: `ResponseMessage`
                },
                data: 'Complete'
            })
        }
    })
})

transmitterService.getIncomingResponse().subscribe(message => {
    if (message.header.messageName == 'RequestMessage') {
        incomingRequest.next(message)
    }
})

// listen to event notification
transmitterService.getEventNotification().subscribe(notification => console.log(notification))